
_MCU_Init:

;pwm_driver_avr.c,76 :: 		void MCU_Init()
;pwm_driver_avr.c,78 :: 		ADC_Init(); // ADC Init
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
	PUSH       R8
	CALL       _ADC_Init+0
;pwm_driver_avr.c,79 :: 		PWM16bit_Init(_PWM16_PHASE_CORRECT_MODE_8BIT, _PWM16_PRESCALER_16bit_8, _PWM16_NON_INVERTED, 255, 1);  // PWM Init
	LDI        R27, 1
	MOV        R7, R27
	LDI        R27, 0
	MOV        R8, R27
	LDI        R27, 255
	MOV        R5, R27
	LDI        R27, 0
	MOV        R6, R27
	LDI        R27, 160
	MOV        R4, R27
	LDI        R27, 2
	MOV        R3, R27
	LDI        R27, 11
	MOV        R2, R27
	CALL       _PWM16bit_Init+0
;pwm_driver_avr.c,80 :: 		PWM16bit_Start(_TIMER1);
	LDI        R27, 1
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       _PWM16bit_Start+0
;pwm_driver_avr.c,81 :: 		PWM16bit_Change_Duty(current_duty, _TIMER1_CH_B);
	LDI        R27, 18
	MOV        R4, R27
	LDS        R2, _current_duty+0
	LDS        R3, _current_duty+1
	CALL       _PWM16bit_Change_Duty+0
;pwm_driver_avr.c,83 :: 		Delay_ms(100);
	LDI        R18, 5
	LDI        R17, 15
	LDI        R16, 242
L_MCU_Init0:
	DEC        R16
	BRNE       L_MCU_Init0
	DEC        R17
	BRNE       L_MCU_Init0
	DEC        R18
	BRNE       L_MCU_Init0
;pwm_driver_avr.c,85 :: 		current_duty = 0; // Initial value for current duty
	LDI        R27, 0
	STS        _current_duty+0, R27
	STS        _current_duty+1, R27
;pwm_driver_avr.c,86 :: 		}
L_end_MCU_Init:
	POP        R8
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _MCU_Init

_Lcd_Display:

;pwm_driver_avr.c,88 :: 		void Lcd_Display()
;pwm_driver_avr.c,90 :: 		Lcd_Cmd(_LCD_CLEAR);                // Clear display
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;pwm_driver_avr.c,91 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);           // Cursor off
	LDI        R27, 12
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;pwm_driver_avr.c,92 :: 		Lcd_Out(1, 1, txt1);                // Write text in first row
	LDI        R27, #lo_addr(_txt1+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt1+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;pwm_driver_avr.c,93 :: 		Lcd_Out(2, 1, txt2);                // Write text in second row
	LDI        R27, #lo_addr(_txt2+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt2+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;pwm_driver_avr.c,94 :: 		Lcd_Out(2, 16, txt3);               // Write text in second row
	LDI        R27, #lo_addr(_txt3+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt3+0)
	MOV        R5, R27
	LDI        R27, 16
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;pwm_driver_avr.c,95 :: 		}
L_end_Lcd_Display:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _Lcd_Display

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;pwm_driver_avr.c,97 :: 		void main()
;pwm_driver_avr.c,99 :: 		MCU_Init();
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	CALL       _MCU_Init+0
;pwm_driver_avr.c,100 :: 		Lcd_Init();                        // Initialize Lcd
	CALL       _Lcd_Init+0
;pwm_driver_avr.c,101 :: 		Lcd_Display();                     // Display Lcd
	CALL       _Lcd_Display+0
;pwm_driver_avr.c,102 :: 		DDA6_bit = 0;                      // Set PORTA pin 6 as input pin for ADC
	IN         R27, DDA6_bit+0
	CBR        R27, BitMask(DDA6_bit+0)
	OUT        DDA6_bit+0, R27
;pwm_driver_avr.c,103 :: 		DDD4_bit = 1;                      // Set PORTD pin 4 as output pin for PWM
	IN         R27, DDD4_bit+0
	SBR        R27, BitMask(DDD4_bit+0)
	OUT        DDD4_bit+0, R27
;pwm_driver_avr.c,105 :: 		while( 1 )  // Playing with Potentiometer P3 you can control current PWM duty cycle. For visual result, look at LED PD4
L_main2:
;pwm_driver_avr.c,110 :: 		adc_rd = ADC_Read(6) & 0x0000FFFF;
	LDI        R27, 6
	MOV        R2, R27
	CALL       _ADC_Read+0
	ANDI       R16, 255
	ANDI       R17, 255
	STS        _adc_rd+0, R16
	STS        _adc_rd+1, R17
;pwm_driver_avr.c,111 :: 		current_duty = adc_rd / 4 ;
	LSR        R17
	ROR        R16
	LSR        R17
	ROR        R16
	STS        _current_duty+0, R16
	STS        _current_duty+1, R17
;pwm_driver_avr.c,113 :: 		cur_duty_byte = cur_duty_byte * 0.39; // 100 / 256
	LDS        R16, _current_duty+0
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	CALL       _float_ulong2fp+0
	LDI        R20, 20
	LDI        R21, 174
	LDI        R22, 199
	LDI        R23, 62
	CALL       _float_fpmul1+0
	CALL       _float_fpint+0
	STD        Y+0, R16
;pwm_driver_avr.c,114 :: 		PWM16bit_Change_Duty(cur_duty_byte, _TIMER1_CH_B);     // Set newly acquired duty
	LDI        R27, 18
	MOV        R4, R27
	MOV        R2, R16
	LDI        R27, 0
	MOV        R3, R27
	CALL       _PWM16bit_Change_Duty+0
;pwm_driver_avr.c,115 :: 		ByteToStr(cur_duty_byte, txt);
	LDI        R27, #lo_addr(_txt+0)
	MOV        R3, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R4, R27
	LDD        R2, Y+0
	CALL       _ByteToStr+0
;pwm_driver_avr.c,116 :: 		Lcd_Out(2, 11, txt);
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDI        R27, 11
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;pwm_driver_avr.c,117 :: 		Delay_ms( 20 );
	LDI        R17, 208
	LDI        R16, 202
L_main4:
	DEC        R16
	BRNE       L_main4
	DEC        R17
	BRNE       L_main4
	NOP
;pwm_driver_avr.c,118 :: 		}
	JMP        L_main2
;pwm_driver_avr.c,119 :: 		}
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
